int sensorPin = A0;
int sensorPin2 = A1;
int speakerPin = 9;
 
void setup() {
  Serial.begin(9600);
  pinMode(speakerPin,OUTPUT);
}
 
void loop() {
  int tone_value = 2 * analogRead(sensorPin);
  int sensor_value = analogRead(sensorPin2);
  int new_tone = get_nearest_tone(tone_value);

  Serial.print("Tone: ");
  Serial.println(tone_value);

  Serial.print("New Tone: ");
  Serial.println(new_tone);

  Serial.print("Sensor: ");
  Serial.println(sensor_value);  
  Serial.println("");
  
  playSweepTone(new_tone, sensor_value);
}

//Sweep the frequency while playing tone
void playSweepTone(int freq, int sensor) 
{
  //Keep track of time
  long start_time = millis();
  long elapsed_time = 0;

  //Calculate period of frequency in microseconds
  long period_us = 1000000/freq;
  
  //Misc settings
  int duration_ms = 500;
  int sweep_period = 100;
  
  //Variable to save new period
  long new_period_us;
  
  //Make sure sensor value is at least 1
  if (sensor < 1)
    sensor = 1;
  
  //Start at normal period
  new_period_us = period_us;
  
  //Do the following for duration_ms milliseconds:
  while (elapsed_time < duration_ms) {
     
      digitalWrite(speakerPin,HIGH);
      delayMicroseconds(new_period_us / 2);

      digitalWrite(speakerPin, LOW);
      delayMicroseconds(new_period_us / 2);
   
      // Keep track of how long we've played this tone
      elapsed_time = millis() - start_time;
      
      // Update period
      new_period_us += (sensor * (elapsed_time % sweep_period)) / sweep_period;
  }
}


int get_nearest_tone(int freq)
{
  if (freq <= 123)
    freq = 123;
  else if (freq <= 131)
    freq = 131;
  else if (freq <= 139)
    freq = 139;
  else if (freq <= 147)
    freq = 147;
  else if (freq <= 156)
    freq = 156;
  else if (freq <= 165)
    freq = 165;
  else if (freq <= 175)
    freq = 175;
  else if (freq <= 185)
    freq = 185;
  else if (freq <= 196)
    freq = 196;
  else if (freq <= 208)
    freq = 208;
  else if (freq <= 233)
    freq = 233;
  else if (freq <= 247)
    freq = 247;
  else if (freq <= 262)
    freq = 262;
  else if (freq <= 277)
    freq = 277;
  else if (freq <= 294)
    freq = 294;
  else if (freq <= 311)
    freq = 311;
  else if (freq <= 330)
    freq = 349;
  else if (freq <= 370)
    freq = 370;
  else if (freq <= 392)
    freq = 392;
  else if (freq <= 415)
    freq = 415;
  else if (freq <= 440)
    freq = 440;
  else if (freq <= 466)
    freq = 466;
  else if (freq <= 494)
    freq = 494;
  else if (freq <= 523)
    freq = 523;
  else if (freq <= 554)
    freq = 554;
  else if (freq <= 587)
    freq = 587;
  else if (freq <= 622)
    freq = 622;
  else if (freq <= 659)
    freq = 659;
  else if (freq <= 698)
    freq = 698;
  else if (freq <= 740)
    freq = 740;
  else if (freq <= 784)
    freq = 784;
  else if (freq <= 831)
    freq = 831;
  else if (freq <= 880)
    freq = 880;
  else if (freq <= 932)
    freq = 932;
  else if (freq <= 988)
    freq = 988;
  else if (freq <= 1047)
    freq = 1047;
  else if (freq <= 1109)
    freq = 1109;
  else if (freq <= 1175)
    freq = 1175;
  else if (freq <= 1245)
    freq = 1245;
  else if (freq <= 1319)
    freq = 1319;
  else if (freq <= 1397)
    freq = 1397;
  else if (freq <= 1480)
    freq = 1480;
  else if (freq <= 1568)
    freq = 1568;
  else if (freq <= 1661)
    freq = 1661;
  else if (freq <= 1760)
    freq = 1760;
  else if (freq <= 1865)
    freq = 1865;
  else if (freq <= 1976)
    freq = 1976;
  else if (freq <= 2093)
    freq = 2093;

  return freq;

}


